classification
Title: Failure to build _ssl module on ubuntu xenial
Type: compile error Stage: resolved
Components: Extension Modules, SSL Versions: Python 3.9, Python 3.8
process
Status: closed Resolution: fixed
Dependencies: Superseder: Let's update ssl error codes
View: 39953
Assigned To: christian.heimes Nosy List: Anthony Sottile, SilentGhost, benjamin.peterson, christian.heimes, miss-islington
Priority: normal Keywords: patch

Created on 2020-04-12 20:16 by Anthony Sottile, last changed 2020-04-14 03:31 by miss-islington. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 19506 merged benjamin.peterson, 2020-04-14 02:49
PR 19507 merged miss-islington, 2020-04-14 03:12
Messages (5)
msg366266 - (view) Author: Anthony Sottile (Anthony Sottile) * Date: 2020-04-12 20:16
Haven't yet bisected, but noticed this in the nightly builds I provide for ubuntu deadsnakes https://github.com/deadsnakes/nightly -- I believe it to be this patch so I've added to nosy: https://github.com/python/cpython/pull/19082

Both python3.8 and python3.9 are currently failing with a similar error:

2020-04-12T15:08:17.0217595Z x86_64-linux-gnu-gcc -pthread -fPIC -Wdate-time -D_FORTIFY_SOURCE=2 -Wno-unused-result -Wsign-compare -DNDEBUG -g -fwrapv -O3 -Wall -g -fstack-protector -Wformat -Werror=format-security -std=c99 -Wextra -Wno-unused-result -Wno-unused-parameter -Wno-missing-field-initializers -Werror=implicit-function-declaration -I../Include/internal -I../Include -IObjects -IPython -I. -I/usr/include/x86_64-linux-gnu -I/tmp/code/Include -I/tmp/code/build-shared -c /tmp/code/Modules/_ssl.c -o build/temp.linux-x86_64-3.8/tmp/code/Modules/_ssl.o
2020-04-12T15:08:17.1350180Z In file included from /tmp/code/Modules/_ssl.c:136:0:
2020-04-12T15:08:17.1351441Z /tmp/code/Modules/_ssl_data.h:6:15: error: ‘ERR_LIB_ASYNC’ undeclared here (not in a function)
2020-04-12T15:08:17.1352097Z      {"ASYNC", ERR_LIB_ASYNC},
2020-04-12T15:08:17.1352338Z                ^
2020-04-12T15:08:17.1355975Z /tmp/code/Modules/_ssl_data.h:13:12: error: ‘ERR_LIB_CT’ undeclared here (not in a function)
2020-04-12T15:08:17.1356503Z      {"CT", ERR_LIB_CT},
2020-04-12T15:08:17.1356692Z             ^
2020-04-12T15:08:17.1357242Z /tmp/code/Modules/_ssl_data.h:19:13: error: ‘ERR_LIB_KDF’ undeclared here (not in a function)
2020-04-12T15:08:17.1357579Z      {"KDF", ERR_LIB_KDF},
2020-04-12T15:08:17.1357784Z              ^
2020-04-12T15:08:17.1366068Z In file included from /tmp/code/Modules/_ssl.c:136:0:
2020-04-12T15:08:17.1366527Z /tmp/code/Modules/_ssl_data.h:598:28: error: initializer element is not constant
2020-04-12T15:08:17.1366913Z      {"FAILED_TO_SET_POOL", ERR_LIB_ASYNC, 101},
2020-04-12T15:08:17.1367202Z                             ^
2020-04-12T15:08:17.1368223Z /tmp/code/Modules/_ssl_data.h:598:28: note: (near initialization for ‘error_codes[112].library’)
2020-04-12T15:08:17.1370670Z /tmp/code/Modules/_ssl_data.h:603:32: error: initializer element is not constant
2020-04-12T15:08:17.1371883Z      {"FAILED_TO_SWAP_CONTEXT", ERR_LIB_ASYNC, 102},
2020-04-12T15:08:17.1372824Z                                 ^
2020-04-12T15:08:17.1374744Z /tmp/code/Modules/_ssl_data.h:603:32: note: (near initialization for ‘error_codes[113].library’)
2020-04-12T15:08:17.1376008Z /tmp/code/Modules/_ssl_data.h:608:21: error: initializer element is not constant
2020-04-12T15:08:17.1377003Z      {"INIT_FAILED", ERR_LIB_ASYNC, 105},
2020-04-12T15:08:17.1377757Z                      ^
2020-04-12T15:08:17.1378839Z /tmp/code/Modules/_ssl_data.h:608:21: note: (near initialization for ‘error_codes[114].library’)
2020-04-12T15:08:17.1379355Z /tmp/code/Modules/_ssl_data.h:613:27: error: initializer element is not constant
2020-04-12T15:08:17.1379774Z      {"INVALID_POOL_SIZE", ERR_LIB_ASYNC, 103},
2020-04-12T15:08:17.1380044Z                            ^
2020-04-12T15:08:17.1380663Z /tmp/code/Modules/_ssl_data.h:613:27: note: (near initialization for ‘error_codes[115].library’)
2020-04-12T15:08:17.1391167Z /tmp/code/Modules/_ssl_data.h:1458:29: error: initializer element is not constant
2020-04-12T15:08:17.1392255Z      {"BASE64_DECODE_ERROR", ERR_LIB_CT, 108},
2020-04-12T15:08:17.1392949Z                              ^
2020-04-12T15:08:17.1394611Z /tmp/code/Modules/_ssl_data.h:1458:29: note: (near initialization for ‘error_codes[284].library’)
2020-04-12T15:08:17.1395718Z /tmp/code/Modules/_ssl_data.h:1463:31: error: initializer element is not constant
2020-04-12T15:08:17.1396628Z      {"INVALID_LOG_ID_LENGTH", ERR_LIB_CT, 100},
2020-04-12T15:08:17.1407884Z                                ^
2020-04-12T15:08:17.1408725Z /tmp/code/Modules/_ssl_data.h:1463:31: note: (near initialization for ‘error_codes[285].library’)
2020-04-12T15:08:17.1409300Z /tmp/code/Modules/_ssl_data.h:1468:26: error: initializer element is not constant
2020-04-12T15:08:17.1409726Z      {"LOG_CONF_INVALID", ERR_LIB_CT, 109},
2020-04-12T15:08:17.1410042Z                           ^
2020-04-12T15:08:17.1410675Z /tmp/code/Modules/_ssl_data.h:1468:26: note: (near initialization for ‘error_codes[286].library’)
2020-04-12T15:08:17.1411199Z /tmp/code/Modules/_ssl_data.h:1473:30: error: initializer element is not constant
2020-04-12T15:08:17.1411612Z      {"LOG_CONF_INVALID_KEY", ERR_LIB_CT, 110},
2020-04-12T15:08:17.1411921Z                               ^
2020-04-12T15:08:17.1412514Z /tmp/code/Modules/_ssl_data.h:1473:30: note: (near initialization for ‘error_codes[287].library’)
2020-04-12T15:08:17.1413202Z /tmp/code/Modules/_ssl_data.h:1478:38: error: initializer element is not constant
2020-04-12T15:08:17.1413930Z      {"LOG_CONF_MISSING_DESCRIPTION", ERR_LIB_CT, 111},
2020-04-12T15:08:17.1414331Z                                       ^
2020-04-12T15:08:17.1415017Z /tmp/code/Modules/_ssl_data.h:1478:38: note: (near initialization for ‘error_codes[288].library’)
2020-04-12T15:08:17.1415594Z /tmp/code/Modules/_ssl_data.h:1483:30: error: initializer element is not constant
2020-04-12T15:08:17.1416189Z      {"LOG_CONF_MISSING_KEY", ERR_LIB_CT, 112},
2020-04-12T15:08:17.1416559Z                               ^
2020-04-12T15:08:17.1417368Z /tmp/code/Modules/_ssl_data.h:1483:30: note: (near initialization for ‘error_codes[289].library’)
2020-04-12T15:08:17.1417934Z /tmp/code/Modules/_ssl_data.h:1488:25: error: initializer element is not constant
2020-04-12T15:08:17.1418395Z      {"LOG_KEY_INVALID", ERR_LIB_CT, 113},
2020-04-12T15:08:17.1418734Z                          ^
2020-04-12T15:08:17.1419625Z /tmp/code/Modules/_ssl_data.h:1488:25: note: (near initialization for ‘error_codes[290].library’)
2020-04-12T15:08:17.1420263Z /tmp/code/Modules/_ssl_data.h:1493:30: error: initializer element is not constant
2020-04-12T15:08:17.1420754Z      {"SCT_FUTURE_TIMESTAMP", ERR_LIB_CT, 116},
2020-04-12T15:08:17.1421155Z                               ^
2020-04-12T15:08:17.1421879Z /tmp/code/Modules/_ssl_data.h:1493:30: note: (near initialization for ‘error_codes[291].library’)
2020-04-12T15:08:17.1422497Z /tmp/code/Modules/_ssl_data.h:1498:21: error: initializer element is not constant
2020-04-12T15:08:17.1422987Z      {"SCT_INVALID", ERR_LIB_CT, 104},
2020-04-12T15:08:17.1423346Z                      ^
2020-04-12T15:08:17.1424075Z /tmp/code/Modules/_ssl_data.h:1498:21: note: (near initialization for ‘error_codes[292].library’)
2020-04-12T15:08:17.1424702Z /tmp/code/Modules/_ssl_data.h:1503:31: error: initializer element is not constant
2020-04-12T15:08:17.1425654Z      {"SCT_INVALID_SIGNATURE", ERR_LIB_CT, 107},
2020-04-12T15:08:17.1426049Z                                ^
2020-04-12T15:08:17.1426851Z /tmp/code/Modules/_ssl_data.h:1503:31: note: (near initialization for ‘error_codes[293].library’)
2020-04-12T15:08:17.1427455Z /tmp/code/Modules/_ssl_data.h:1508:26: error: initializer element is not constant
2020-04-12T15:08:17.1427950Z      {"SCT_LIST_INVALID", ERR_LIB_CT, 105},
2020-04-12T15:08:17.1428323Z                           ^
2020-04-12T15:08:17.1429049Z /tmp/code/Modules/_ssl_data.h:1508:26: note: (near initialization for ‘error_codes[294].library’)
2020-04-12T15:08:17.1429685Z /tmp/code/Modules/_ssl_data.h:1513:29: error: initializer element is not constant
2020-04-12T15:08:17.1430181Z      {"SCT_LOG_ID_MISMATCH", ERR_LIB_CT, 114},
2020-04-12T15:08:17.1430592Z                              ^
2020-04-12T15:08:17.1431317Z /tmp/code/Modules/_ssl_data.h:1513:29: note: (near initialization for ‘error_codes[295].library’)
2020-04-12T15:08:17.1431922Z /tmp/code/Modules/_ssl_data.h:1518:21: error: initializer element is not constant
2020-04-12T15:08:17.1432389Z      {"SCT_NOT_SET", ERR_LIB_CT, 106},
2020-04-12T15:08:17.1432774Z                      ^
2020-04-12T15:08:17.1433487Z /tmp/code/Modules/_ssl_data.h:1518:21: note: (near initialization for ‘error_codes[296].library’)
2020-04-12T15:08:17.1434091Z /tmp/code/Modules/_ssl_data.h:1523:33: error: initializer element is not constant
2020-04-12T15:08:17.1434602Z      {"SCT_UNSUPPORTED_VERSION", ERR_LIB_CT, 115},
2020-04-12T15:08:17.1435008Z                                  ^
2020-04-12T15:08:17.1437511Z /tmp/code/Modules/_ssl_data.h:1523:33: note: (near initialization for ‘error_codes[297].library’)
2020-04-12T15:08:17.1438038Z /tmp/code/Modules/_ssl_data.h:1528:36: error: initializer element is not constant
2020-04-12T15:08:17.1438427Z      {"UNRECOGNIZED_SIGNATURE_NID", ERR_LIB_CT, 101},
2020-04-12T15:08:17.1438737Z                                     ^
2020-04-12T15:08:17.1439350Z /tmp/code/Modules/_ssl_data.h:1528:36: note: (near initialization for ‘error_codes[298].library’)
2020-04-12T15:08:17.1439852Z /tmp/code/Modules/_ssl_data.h:1533:32: error: initializer element is not constant
2020-04-12T15:08:17.1440237Z      {"UNSUPPORTED_ENTRY_TYPE", ERR_LIB_CT, 102},
2020-04-12T15:08:17.1440533Z                                 ^
2020-04-12T15:08:17.1441138Z /tmp/code/Modules/_ssl_data.h:1533:32: note: (near initialization for ‘error_codes[299].library’)
2020-04-12T15:08:17.1441633Z /tmp/code/Modules/_ssl_data.h:1538:29: error: initializer element is not constant
2020-04-12T15:08:17.1442122Z      {"UNSUPPORTED_VERSION", ERR_LIB_CT, 103},
2020-04-12T15:08:17.1442407Z                              ^
2020-04-12T15:08:17.1443077Z /tmp/code/Modules/_ssl_data.h:1538:29: note: (near initialization for ‘error_codes[300].library’)
2020-04-12T15:08:17.1443577Z /tmp/code/Modules/_ssl_data.h:2598:24: error: initializer element is not constant
2020-04-12T15:08:17.1443946Z      {"INVALID_DIGEST", ERR_LIB_KDF, 100},
2020-04-12T15:08:17.1444216Z                         ^
2020-04-12T15:08:17.1444808Z /tmp/code/Modules/_ssl_data.h:2598:24: note: (near initialization for ‘error_codes[512].library’)
2020-04-12T15:08:17.1445308Z /tmp/code/Modules/_ssl_data.h:2603:33: error: initializer element is not constant
2020-04-12T15:08:17.1445693Z      {"MISSING_ITERATION_COUNT", ERR_LIB_KDF, 109},
2020-04-12T15:08:17.1445977Z                                  ^
2020-04-12T15:08:17.1446599Z /tmp/code/Modules/_ssl_data.h:2603:33: note: (near initialization for ‘error_codes[513].library’)
2020-04-12T15:08:17.1447090Z /tmp/code/Modules/_ssl_data.h:2608:21: error: initializer element is not constant
2020-04-12T15:08:17.1447467Z      {"MISSING_KEY", ERR_LIB_KDF, 104},
2020-04-12T15:08:17.1447717Z                      ^
2020-04-12T15:08:17.1448313Z /tmp/code/Modules/_ssl_data.h:2608:21: note: (near initialization for ‘error_codes[514].library’)
2020-04-12T15:08:17.1448796Z /tmp/code/Modules/_ssl_data.h:2613:32: error: initializer element is not constant
2020-04-12T15:08:17.1449194Z      {"MISSING_MESSAGE_DIGEST", ERR_LIB_KDF, 105},
2020-04-12T15:08:17.1449475Z                                 ^
2020-04-12T15:08:17.1450094Z /tmp/code/Modules/_ssl_data.h:2613:32: note: (near initialization for ‘error_codes[515].library’)
2020-04-12T15:08:17.1450579Z /tmp/code/Modules/_ssl_data.h:2618:27: error: initializer element is not constant
2020-04-12T15:08:17.1450972Z      {"MISSING_PARAMETER", ERR_LIB_KDF, 101},
2020-04-12T15:08:17.1451236Z                            ^
2020-04-12T15:08:17.1451856Z /tmp/code/Modules/_ssl_data.h:2618:27: note: (near initialization for ‘error_codes[516].library’)
2020-04-12T15:08:17.1452339Z /tmp/code/Modules/_ssl_data.h:2623:22: error: initializer element is not constant
2020-04-12T15:08:17.1452727Z      {"MISSING_PASS", ERR_LIB_KDF, 110},
2020-04-12T15:08:17.1452973Z                       ^
2020-04-12T15:08:17.1453578Z /tmp/code/Modules/_ssl_data.h:2623:22: note: (near initialization for ‘error_codes[517].library’)
2020-04-12T15:08:17.1454058Z /tmp/code/Modules/_ssl_data.h:2628:22: error: initializer element is not constant
2020-04-12T15:08:17.1454436Z      {"MISSING_SALT", ERR_LIB_KDF, 111},
2020-04-12T15:08:17.1454680Z                       ^
2020-04-12T15:08:17.1455277Z /tmp/code/Modules/_ssl_data.h:2628:22: note: (near initialization for ‘error_codes[518].library’)
2020-04-12T15:08:17.1455758Z /tmp/code/Modules/_ssl_data.h:2633:24: error: initializer element is not constant
2020-04-12T15:08:17.1456145Z      {"MISSING_SECRET", ERR_LIB_KDF, 107},
2020-04-12T15:08:17.1456406Z                         ^
2020-04-12T15:08:17.1457006Z /tmp/code/Modules/_ssl_data.h:2633:24: note: (near initialization for ‘error_codes[519].library’)
2020-04-12T15:08:17.1457495Z /tmp/code/Modules/_ssl_data.h:2638:22: error: initializer element is not constant
2020-04-12T15:08:17.1457874Z      {"MISSING_SEED", ERR_LIB_KDF, 106},
2020-04-12T15:08:17.1458120Z                       ^
2020-04-12T15:08:17.1458720Z /tmp/code/Modules/_ssl_data.h:2638:22: note: (near initialization for ‘error_codes[520].library’)
2020-04-12T15:08:17.1459200Z /tmp/code/Modules/_ssl_data.h:2643:32: error: initializer element is not constant
2020-04-12T15:08:17.1459597Z      {"UNKNOWN_PARAMETER_TYPE", ERR_LIB_KDF, 103},
2020-04-12T15:08:17.1459878Z                                 ^
2020-04-12T15:08:17.1460496Z /tmp/code/Modules/_ssl_data.h:2643:32: note: (near initialization for ‘error_codes[521].library’)
2020-04-12T15:08:17.1460976Z /tmp/code/Modules/_ssl_data.h:2648:21: error: initializer element is not constant
2020-04-12T15:08:17.1461411Z      {"VALUE_ERROR", ERR_LIB_KDF, 108},
2020-04-12T15:08:17.1461655Z                      ^
2020-04-12T15:08:17.1462262Z /tmp/code/Modules/_ssl_data.h:2648:21: note: (near initialization for ‘error_codes[522].library’)
2020-04-12T15:08:17.1462798Z /tmp/code/Modules/_ssl_data.h:2653:23: error: initializer element is not constant
2020-04-12T15:08:17.1463177Z      {"VALUE_MISSING", ERR_LIB_KDF, 102},
2020-04-12T15:08:17.1463427Z                        ^
2020-04-12T15:08:17.1464034Z /tmp/code/Modules/_ssl_data.h:2653:23: note: (near initialization for ‘error_codes[523].library’)


Here's a link to a full compile: https://dev.azure.com/deadsnakes/fd93d290-ae2b-4409-ab75-b3679f781215/_apis/build/builds/277/logs/89
msg366285 - (view) Author: SilentGhost (SilentGhost) * (Python triager) Date: 2020-04-13 06:13
This should have been fixed already in #39953. Do re-open, if you can reproduce this with the latest checkouts.
msg366317 - (view) Author: Anthony Sottile (Anthony Sottile) * Date: 2020-04-13 16:57
yes, it is still broken, now with fewer errors:

2020-04-13T15:06:34.7330649Z x86_64-linux-gnu-gcc -pthread -fPIC -Wdate-time -D_FORTIFY_SOURCE=2 -Wno-unused-result -Wsign-compare -DNDEBUG -g -fwrapv -O3 -Wall -g -fstack-protector -Wformat -Werror=format-security -std=c99 -Wextra -Wno-unused-result -Wno-unused-parameter -Wno-missing-field-initializers -Werror=implicit-function-declaration -fvisibility=hidden -I../Include/internal -I../Include -IObjects -IPython -I. -I/usr/include/x86_64-linux-gnu -I/tmp/code/Include -I/tmp/code/build-static -c /tmp/code/Modules/_ssl.c -o build/temp.linux-x86_64-3.9/tmp/code/Modules/_ssl.o
2020-04-13T15:06:34.8649844Z In file included from /tmp/code/Modules/_ssl.c:136:0:
2020-04-13T15:06:34.8651190Z /tmp/code/Modules/_ssl_data.h:650:28: error: ‘ERR_LIB_ASYNC’ undeclared here (not in a function)
2020-04-13T15:06:34.8651651Z      {"FAILED_TO_SET_POOL", ERR_LIB_ASYNC, 101},
2020-04-13T15:06:34.8651920Z                             ^
2020-04-13T15:06:34.8661090Z /tmp/code/Modules/_ssl_data.h:1510:29: error: ‘ERR_LIB_CT’ undeclared here (not in a function)
2020-04-13T15:06:34.8661535Z      {"BASE64_DECODE_ERROR", ERR_LIB_CT, 108},
2020-04-13T15:06:34.8661802Z                              ^
2020-04-13T15:06:34.8676472Z /tmp/code/Modules/_ssl_data.h:2650:24: error: ‘ERR_LIB_KDF’ undeclared here (not in a function)
2020-04-13T15:06:34.8676957Z      {"INVALID_DIGEST", ERR_LIB_KDF, 100},
2020-04-13T15:06:34.8677361Z                         ^
msg366360 - (view) Author: Benjamin Peterson (benjamin.peterson) * (Python committer) Date: 2020-04-14 03:11
New changeset 584a3cfda4d7a65ea0c1ea1ee541378bb7be46ca by Benjamin Peterson in branch 'master':
closes bpo-40266, closes bpo-39953: Use numeric lib code if compiling against old OpenSSL. (GH-19506)
https://github.com/python/cpython/commit/584a3cfda4d7a65ea0c1ea1ee541378bb7be46ca
msg366362 - (view) Author: miss-islington (miss-islington) Date: 2020-04-14 03:31
New changeset c496e29c2bd0c29327c93174d5a40d2dc5a09402 by Miss Islington (bot) in branch '3.8':
closes bpo-40266, closes bpo-39953: Use numeric lib code if compiling against old OpenSSL. (GH-19506)
https://github.com/python/cpython/commit/c496e29c2bd0c29327c93174d5a40d2dc5a09402
History
Date User Action Args
2020-04-14 03:31:25miss-islingtonsetmessages: + msg366362
2020-04-14 03:12:08miss-islingtonsetnosy: + miss-islington

pull_requests: + pull_request18858
2020-04-14 03:11:51benjamin.petersonsetstatus: open -> closed
resolution: duplicate -> fixed
messages: + msg366360

stage: patch review -> resolved
2020-04-14 02:49:16benjamin.petersonsetkeywords: + patch
stage: resolved -> patch review
pull_requests: + pull_request18857
2020-04-13 16:57:13Anthony Sottilesetstatus: closed -> open

messages: + msg366317
2020-04-13 06:13:30SilentGhostsetstatus: open -> closed

superseder: Let's update ssl error codes

nosy: + SilentGhost
messages: + msg366285
resolution: duplicate
stage: resolved
2020-04-12 20:16:49Anthony Sottilecreate